/*
 * Simple Inventory API
 * This is a simple API
 *
 * OpenAPI spec version: 1.0.0
 * Contact: you@your-company.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package fr.cea.fhe.repository;

import fr.cea.fhe.isi.models.ISIResponseItem;
import fr.cea.kemanager.lib.Pair;
import fr.cea.kemanager.lib.client.ApiCallback;
import fr.cea.kemanager.lib.client.ApiClient;
import fr.cea.kemanager.lib.client.ApiException;
import fr.cea.kemanager.lib.client.ApiResponse;
import fr.cea.kemanager.lib.client.Configuration;
import fr.cea.kemanager.lib.client.ProgressRequestBody;
import fr.cea.kemanager.lib.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;
import java.io.File;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

public class IsiapiApiRepository {
    private ApiClient apiClient;

    public IsiapiApiRepository() {
        this(Configuration.getDefaultApiClient());
    }

    public IsiapiApiRepository(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for isiCreateDpo
     * @param norm  (required)
     * @param inputMetadata The metadata for CTI (optional)
     * @param fileToSubmit The CTI data. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call isiCreateDpoCall(Boolean norm, String inputMetadata, File fileToSubmit, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/isi-api/v1/dpo"
            .replaceAll("\\{" + "norm" + "\\}", apiClient.escapeString(norm.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (inputMetadata != null)
        localVarFormParams.put("input_metadata", inputMetadata);
        if (fileToSubmit != null)
        localVarFormParams.put("fileToSubmit", fileToSubmit);

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "multipart/form-data"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call isiCreateDpoValidateBeforeCall(Boolean norm, String inputMetadata, File fileToSubmit, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'norm' is set
        if (norm == null) {
            throw new ApiException("Missing the required parameter 'norm' when calling isiCreateDpo(Async)");
        }
        

        com.squareup.okhttp.Call call = isiCreateDpoCall(norm, inputMetadata, fileToSubmit, progressListener, progressRequestListener);
        return call;

    }

    /**
     * create a dpo data with a required DSA Id in metadata input
     * store object with Metadata in DPOS througout ISI platform
     * @param norm  (required)
     * @param inputMetadata The metadata for CTI (optional)
     * @param fileToSubmit The CTI data. (optional)
     * @return ISIResponseItem
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ISIResponseItem isiCreateDpo(Boolean norm, String inputMetadata, File fileToSubmit) throws ApiException {
        ApiResponse<ISIResponseItem> resp = isiCreateDpoWithHttpInfo(norm, inputMetadata, fileToSubmit);
        return resp.getData();
    }

    /**
     * create a dpo data with a required DSA Id in metadata input
     * store object with Metadata in DPOS througout ISI platform
     * @param norm  (required)
     * @param inputMetadata The metadata for CTI (optional)
     * @param fileToSubmit The CTI data. (optional)
     * @return ApiResponse&lt;ISIResponseItem&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ISIResponseItem> isiCreateDpoWithHttpInfo(Boolean norm, String inputMetadata, File fileToSubmit) throws ApiException {
        com.squareup.okhttp.Call call = isiCreateDpoValidateBeforeCall(norm, inputMetadata, fileToSubmit, null, null);
        Type localVarReturnType = new TypeToken<ISIResponseItem>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * create a dpo data with a required DSA Id in metadata input (asynchronously)
     * store object with Metadata in DPOS througout ISI platform
     * @param norm  (required)
     * @param inputMetadata The metadata for CTI (optional)
     * @param fileToSubmit The CTI data. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call isiCreateDpoAsync(Boolean norm, String inputMetadata, File fileToSubmit, final ApiCallback<ISIResponseItem> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = isiCreateDpoValidateBeforeCall(norm, inputMetadata, fileToSubmit, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ISIResponseItem>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
